rui = {}
rui.Context = UI.CreateContext("Context")
rui.Context:SetSecureMode("restricted")
rui.Window = UI.CreateFrame("Frame", "MainWindow", rui.Context)
rui.Window:SetSecureMode("restricted")
rui.WindowClick = UI.CreateFrame("Texture", "click frame", rui.Window)
rui.WindowClick:SetSecureMode("restricted")
rui.WindowClickText = UI.CreateFrame("Text", "click text", rui.Window)
rui.WindowResize = UI.CreateFrame("Texture", "resize button", rui.Window)
rui.clickOffset = {x = 0, y = 0}
rui.resizeOffset = {x = 0, y = 0}
rui.windowdragActive = false
rui.windowResizeActive = false

local function ruiCreateWindow()
rui.Window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ruiValues.locmainx, ruiValues.locmainy)
rui.Window:SetWidth(ruiValues.mainwidth)
rui.Window:SetHeight(ruiValues.mainheight)

rui.WindowClick:SetTexture("Reloadui", "button.png")
rui.WindowClick:SetPoint("TOPLEFT", rui.Window, "TOPLEFT")
rui.WindowClick:SetPoint("BOTTOMRIGHT", rui.Window, "BOTTOMRIGHT")
rui.WindowClick:SetLayer(1)
rui.WindowClickText:SetPoint("CENTER", rui.WindowClick, "CENTER")
rui.WindowClickText:SetText("/Reloadui")
rui.WindowClickText:SetLayer(2)
rui.WindowClickText:SetFontSize(16)
rui.WindowResize:SetTexture("Reloadui", "resize.png")
rui.WindowResize:SetPoint("BOTTOMRIGHT", rui.WindowClick, "BOTTOMRIGHT")
rui.WindowResize:SetLayer(3)

rui.WindowClick.Event.RightClick   = "reloadui"

	function rui.WindowClick.Event:LeftDown()
			rui.windowdragActive = true
			local mouseStatus = Inspect.Mouse()
			rui.clickOffset["x"] = mouseStatus.x - ruiValues.locmainx
			rui.clickOffset["y"] = mouseStatus.y - ruiValues.locmainy
	end
	function rui.WindowClick.Event:LeftUp()
		rui.windowdragActive = false
	end
	function rui.WindowClick.Event:LeftUpoutside()
		rui.windowdragActive = false
	end
	function rui.WindowClick.Event:MouseMove(x,y)
		if ruiValues.isincombat then return end
		if rui.windowdragActive == true then
			ruiValues.locmainx = x - rui.clickOffset["x"]
			ruiValues.locmainy = y - rui.clickOffset["y"]	
			rui.Window:SetPoint("TOPLEFT", rui.Context, "TOPLEFT", ruiValues.locmainx, ruiValues.locmainy)
		end
	end

	function rui.WindowResize.Event:LeftDown()
			windowResizeActive = true
			local mouseStatus = Inspect.Mouse()
			rui.clickOffset["x"] = mouseStatus.x
			rui.clickOffset["y"] = mouseStatus.y
			rui.resizeOffset["x"] = ruiValues.mainwidth
			rui.resizeOffset["y"] = ruiValues.mainheight
	end
	function rui.WindowResize.Event:LeftUp()
		windowResizeActive = false
		ruiValues.mainwidth = rui.Window:GetWidth()
		ruiValues.mainheight = rui.Window:GetHeight()
	end
	function rui.WindowResize.Event:LeftUpoutside()
		windowResizeActive = false
	end
	function rui.WindowResize.Event:MouseMove(x,y)
		if windowResizeActive == true then
			rui.Window:SetWidth(math.ceil(rui.resizeOffset["x"] + (x - rui.clickOffset["x"])))
			rui.Window:SetHeight(math.ceil(rui.resizeOffset["y"] + (y - rui.clickOffset["y"])))
		end
	end

	if ruiValues.windowstate == true then rui.Window:SetVisible(true) end
end	
	
function ruiCombatEnter()
	ruiValues.isincombat = true
end

function ruiCombatLeave()
	ruiValues.isincombat = false
end

local function ruiloadSettings()
	if ruiValues == nil then
		ruiValues = {windowstate = true, locmainx = 0, locmainy = 0, mainheight = 80, mainwidth = 150}
		ruiValues.locmainx = ((UIParent:GetRight() / 2) - 100)
		ruiValues.locmainy = ((UIParent:GetBottom() / 2) - 50)
	end
	if ruiValues.mainwidth == nil then ruiValues.mainwidth = 150 end
	if ruiValues.mainheight == nil then ruiValues.mainheight = 80 end
	ruiCreateWindow()
	print ("/reload to toggle Reloadui window")
end

local function ruiSlashCommand()
	if ruiValues.isincombat then return end
	ruiValues.windowstate = (ruiValues.windowstate == false)
	rui.Window:SetVisible(ruiValues.windowstate)
end

table.insert(Command.Slash.Register("reload"), {ruiSlashCommand, "Reloadui", "ruiSlashCommand"})
table.insert(Event.Addon.Startup.End, {ruiloadSettings, "Reloadui", "ruiloadSettings"})
table.insert(Event.System.Secure.Enter, {ruiCombatEnter, "Reloadui", "ruiCombatEnter"})
table.insert(Event.System.Secure.Leave, {ruiCombatLeave, "Reloadui", "ruiCombatLeave"})


